#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>
#import "PMTPSharedCocoaUtilities.h"


NSString *PMTPLocalizedString(NSString *theOriginalString);

NSString *PMTPPreferencePanePath(NSString *theName);


@interface NSImage (PMTPExtensions)

	+ (NSImage*)bundleImageNamed: (NSString*)theName ofType: (NSString*)theType;

@end


@interface NSPasteboard (PMTPExtensions)

	- (BOOL)duplicateToPasteboard: (NSPasteboard*)theDuplicatePasteboard;

@end


@interface NSMutableDictionary (PMTPExtensions)

	- (void)setHasValidSnippetAbbreviation: (BOOL)flag;

@end


@interface NSDictionary (PMTPExtensions)

	- (BOOL)hasValidSnippetAbbreviationForCollection: (NSArray*)theSnippets collectionSize: (int)theNumberOfSnippets expandsImmediately: (BOOL)expandsImmediately;
	- (BOOL)hasValidSnippetAbbreviation;

@end


@interface NSAttributedString (PMTPExtensions)

	- (id)attributedStringByDeletingFirstOccurenceString: (NSString*)theTarget;
	- (id)attributedStringByReplacingDateFormattersWithDate: (NSCalendarDate*)theDate locale: (NSDictionary*)theLocale caseConversionMode: (int)theCaseConversionMode;

@end


@interface NSString (PMTPExtensions)

	- (id)stringByDeletingFirstOccurenceString: (NSString*)theTarget;
	- (id)stringByReplacingDateFormattersWithDate: (NSCalendarDate*)theDate locale: (NSDictionary*)theLocale caseConversionMode: (int)theCaseConversionMode;

@end


@interface NSObject (PMTPExtensions)

	- (void)replaceDateFormattersWithDate: (NSCalendarDate*)theDate locale: (NSDictionary*)theLocale caseConversionMode: (int)theCaseConversionMode;

@end
