#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>


@interface PMTPDaemonController: NSObject 

	{
		BOOL isClientSnippetsMissing;
		int clientSeparatorIndex;
		int expansionMode;
		BOOL canSelectWords;
		BOOL restorePasteboard;

		NSStatusItem *statusItem;
		NSMutableString *keyLog;
		NSMutableArray *exceptions;
		NSSound *bubble;
		NSPasteboard *currentPasteboardBackup;
		NSTimer *pasteboardNormalizationTimer;
	}

	+ (id)daemonController;

	- (NSMutableDictionary*)reloadSettings: (BOOL)forceReload;
	- (NSMutableDictionary*)settings;
	- (id)valueForSetting: (NSString*)theSetting;
	- (id)unarchivedValueForSetting: (NSString*)theSetting;
	- (BOOL)boolForSetting: (NSString*)theSetting;
	- (int)integerForSetting: (NSString*)theSetting;

	- (void)checkAXAPI: (id)sender;
	- (void)issueDelayedActions;
	- (void)cancelDelayedActions;

	- (void)updateParametersForSettingsChange: (id)sender;
	- (void)updateParametersForClientPath: (id)sender;

	- (void)keyLog: (NSEvent*)theEvent;
	- (void)clearKeyLog: (id)sender;

	- (BOOL)handleAbbreviation: (NSString*)theAbbreviation;

	- (void)stopPasteboardNormalizationTimer;
	- (void)normalizePasteboard;
	- (void)schedulePasteboardNormalization;
	- (BOOL)pasteSnippet: (NSDictionary*)theSnippet forAbbreviation: (NSString*)theEnteredAbbreviation abbreviationMode: (int)theAbbreviationMode replacementMode: (int)theReplacementMode;

	- (void)cleanUp;
	- (void)quitDeliberately: (id)sender;

@end


static OSStatus PMTPInvalidateLog(EventHandlerCallRef inHandlerCallRef, EventRef inEvent, void *inUserData);
static OSStatus PMTPLogKeyEvent(EventHandlerCallRef inHandlerCallRef, EventRef inEvent, void *inUserData);
